<?php
/**
 * tsCalcCaptcha
 * 
 * @version    2.0.0
 * @author     Markus Nolte
 * @copyright  Copyright (c) 2013 Top-Side.de
 * @license    CC BY-NC-SA 3.0 DE (http://creativecommons.org/licenses/by-nc-sa/3.0/de/)
 * @link       http://www.top-side.de
 * 
 */

session_start();

function random_color($image, $min = 0, $max = 199)
{
	$r = mt_rand($min, $max);
	$g = mt_rand($min, $max);
	$b = mt_rand($min, $max);
	$color = imagecolorexact($image, $r, $g, $b);
	if($color == -1)
	{
		if(imagecolorstotal($image) >= 255)
			$color = imagecolorclosest($image, $r, $g, $b);
		else
			$color = imagecolorallocate($image, $r, $g, $b);
	}
	return $color;
}

$width = 200;
$height = 50;
$image = imagecreate($width, $height);
random_color($image, 200, 255);

for($i = 0; $i < ($width * $height) / 3; $i++)
{
	$color = random_color($image);
	imagefilledellipse($image, mt_rand(0, $width), mt_rand(0, $height), 1, 1, $color);
}

$num1 = mt_rand(0, 9);
$num2 = mt_rand(0, 9);
$strings = array($num1, "+", $num2);
$font = dirname(__FILE__)."/font.ttf";
$space = 25;
for($i = 0; $i < count($strings); $i++)
{
	$color = random_color($image);
	((bool)mt_rand(0, 1)) ? $angle = mt_rand(0, 30) : $angle = mt_rand(330, 360);
	imagettftext($image, 35, $angle, $space, mt_rand(35, 45), $color, $font, $strings[$i]);
	$space += mt_rand(25, 75);
}
$_SESSION['captcha'] = $num1 + $num2;

header("Content-Type: image/png");
imagepng($image);
imagedestroy($image);
?>