<?php
/**
 * tsCaptcha
 * 
 * @version    2.0.0
 * @author     Markus Nolte
 * @copyright  Copyright (c) 2013 Top-Side.de
 * @license    CC BY-NC-SA 3.0 DE (http://creativecommons.org/licenses/by-nc-sa/3.0/de/)
 * @link       http://www.top-side.de
 * 
 */

session_start();

function random_color($image, $min = 0, $max = 199)
{
	$r = mt_rand($min, $max);
	$g = mt_rand($min, $max);
	$b = mt_rand($min, $max);
	$color = imagecolorexact($image, $r, $g, $b);
	if($color == -1)
	{
		if(imagecolorstotal($image) >= 255)
			$color = imagecolorclosest($image, $r, $g, $b);
		else
			$color = imagecolorallocate($image, $r, $g, $b);
	}
	return $color;
}

$width = 200;
$height = 50;
$image = imagecreate($width, $height);
random_color($image, 200, 255);

for($i = 0; $i < ($width * $height) / 3; $i++)
{
	$color = random_color($image);
	imagefilledellipse($image, mt_rand(0, $width), mt_rand(0, $height), 1, 1, $color);
}

$chars = "ABCDEFGHIJKLMNPQRSTUVWXYZ123456789";
$captcha = "";
$font = dirname(__FILE__)."/font.ttf";
$space = 15;
for($i = 0; $i < 5; $i++)
{
	$char = $chars[mt_rand(0, strlen($chars) - 1)];
	$captcha .= $char;
	$color = random_color($image);
	((bool)mt_rand(0, 1)) ? $angle = mt_rand(0, 30) : $angle = mt_rand(330, 360);
	imagettftext($image, 30, $angle, $space, mt_rand(35, 45), $color, $font, $char);
	$space += mt_rand(25, 40);
}
$_SESSION['captcha'] = $captcha;

header("Content-Type: image/png");
imagepng($image);
imagedestroy($image);
?>