<?php
/**
 * tsGuestbook Funktionen
 * 
 * @version    1.0.0
 * @copyright  Copyright (c) 2013 Top-Side.de
 * 
 */
$weekday = array("Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag");
$smileys = array(
	":-)" => "smile", ":-D" => "grin", ";-)" => "wink", "8-0" => "surprise", "8-)" => "eek",
	":-P" => "tongue", "|-O" => "cool", "0:)" => "angel", "-_-" => "sleep", "$-)" => "money",
	":^*" => "kiss", ":$" => "red", "%-)" => "confuse", ":-(" => "sad", ":;(" => "cry",
	"):/" => "roll", "D:(" => "mad", "):|" => "evil", ":-0" => "yell", ":-#" => "zipper" 
);

function trim_text($text)
{
	if(strlen($text) > 30)
		$text = substr($text, 0, 30)."...";
	return $text;
}

function clean_up($input)
{
	$output = stripslashes($input);
	$output = strip_tags($output);
	$output = preg_replace("/(\r\n){4,}/", "\n\n", $output);
	$output = str_replace("|@|", " ", $output);
	
	return $output;
}

function generate_html($input)
{
	$output = htmlspecialchars($input, ENT_QUOTES, "UTF-8");
	$output = replace_umlaute($output);
	$output = nl2br($output);
	$output = preg_replace("/(\r|\n|\t)/", "", $output);
	
	return $output;
}

function replace_umlaute($text)
{
	$umlaute = array("//","//","//","//","//","//","//");
	$htmltag = array("&auml;","&ouml;","&uuml;","&Auml;","&Ouml;","&Uuml;","&szlig;");
	return utf8_encode(preg_replace($umlaute, $htmltag, utf8_decode($text)));
}

function reload_lock($reload_ticks)
{
	$reload_lock = 0;
	$ip = $_SERVER['REMOTE_ADDR'];
	$time = time();
	$file = file(DIR_DATA."/reload");
	$new_content = "";
	for($i = 0; $i < sizeof($file); $i++)
	{
		$item = explode("|", $file[$i]);
		if($item[0] > $time - $reload_ticks)
		{
			if(trim($item[1]) == $ip)
				$reload_lock = $reload_ticks - ($time - $item[0]);
			$new_content .= $file[$i];
		}		
	}
	if($reload_lock == 0)
		$new_content .= $time."|".$ip."\n";
	$handle = fopen(DIR_DATA."/reload", "w");
	fwrite($handle, $new_content);
	fclose($handle);
	return $reload_lock;
}

function bb_code($input, $smileys_enabled = true)
{
	global $smileys, $settings;
	$input = str_replace('\"', '"', $input);
	if($settings['BBCODES_ENABLED'])
	{
		$input = preg_replace("/\[b\](.*)\[\/b\]/Usi", "<strong>\\1</strong>", $input);
		$input = preg_replace("/\[i\](.*)\[\/i\]/Usi", "<em>\\1</em>", $input);
		$input = preg_replace("/\[u\](.*)\[\/u\]/Usi", "<span class=\"underline\">\\1</span>", $input);
		$input = preg_replace("/\[url\](.*)\[\/url\]/Usi", "<a href=\"\\1\">\\1</a>", $input); 
		$input = preg_replace("/\[url=(.*)\](.*)\[\/url\]/Usi", "<a href=\"\\1\">\\2</a>", $input);
		$input = preg_replace("/\[img\](.*)\[\/img\]/Usi", "<img src=\"\\1\" style=\"max-width: ".$settings['IMG_MAX_WIDTH']."px; max-height: ".$settings['IMG_MAX_HEIGHT']."px\" alt=\"\" />", $input);
	}
	if($settings['SMILEYS_ENABLED'] && $smileys_enabled)
	{
		foreach($smileys as $shortcut => $name)
			$input = str_replace($shortcut, "<img src=\"".DIR_IMAGES_SMILEYS."/".$name.".png\" alt=\"".$shortcut."\" />", $input);
	}
	$input = preg_replace("/\\[\/?.*\]/Usi", "", $input);
	return $input;
}

function insert_entry($entry)
{
	$filename = DIR_DATA."/content";	
	$file = array_reverse(file($filename));
	$count = sizeof($file);
	if($count == 0)
	{		
		$handle = fopen($filename, "a");
		fwrite($handle, $entry);
		fclose($handle);
	}
	else
	{
		$key_new_entry = explode("|@|", $entry);
		for($i = 0; $i < $count; $i++)
		{
			$key_current_entry = explode("|@|", $file[$i]);
			if($key_new_entry[0] > $key_current_entry[0])
			{
				$entries = file($filename);
				$entries[$count - $i - 1] = $file[$i].$entry;
				$handle = fopen($filename, "w");
				fputs($handle, implode("", $entries));
				fclose($handle);
				break;
			}
		}
	}
}

function display_entry($item, $number, $show_comment = true)
{
	global $settings, $weekday;
	
	$date = intval($item[0]);
	$name = $item[1];
	$mail = $item[2];
	if(strpos($item[2], "#") !== false)
	{
		if($_SESSION['login'])
			$mail = substr($mail, 1);
		else
			$mail = "";
	}
	$homepage = $item[3];
	$entry = bb_code($item[4]);
	$comment = $item[5];
	$ip = (count($item) > 7 && $_SESSION['login']) ? $item[6] : "";
	
	switch($settings['LAYOUT'])
	{
		default:
		{
			echo "<tr>\n";
			echo "<td class=\"cell_left\">\n";
			echo "#".$number.": <strong>".$name."</strong><br /><br />\n";
			if(!empty($mail))
				echo "<img src=\"".DIR_IMAGES_ICONS."/mail.png\" alt=\"E-Mail\" />&nbsp;<a href=\"mailto:".$mail."\">".trim_text($mail)."</a><br />\n";
			if(!empty($homepage))
				echo "<img src=\"".DIR_IMAGES_ICONS."/homepage.png\" alt=\"Homepage\" />&nbsp;<a href=\"".$homepage."\">".trim_text($homepage)."</a><br />\n";
			if(!empty($ip))
				echo "<img src=\"".DIR_IMAGES_ICONS."/ip.png\" alt=\"IP-Adresse\" />&nbsp;".$ip."<br />\n";
			echo "</td>\n";
			echo "<td class=\"cell_right\">\n";
			echo "<div class=\"text_small text_right\"><img src=\"".DIR_IMAGES_ICONS."/calendar.png\" alt=\"Kalendar\" />&nbsp;";
			echo $weekday[date("w", $date)].", ".date("d.m.Y - H:i:s", $date)."</div>\n";
			echo "<div class=\"word_wrap\">".$entry."</div>\n";
			echo "</td>\n";
			echo "</tr>\n";
			if($show_comment && !empty($comment))
				echo "<tr><td colspan=\"2\" class=\"cell_border\"><strong>Kommentar</strong><br />".$comment."</td></tr>\n";
			break;
		}
		case 1:
		{
			echo "<tr>\n";
			echo "<td class=\"cell_left\"><strong>Nr.:</strong> ".$number."&nbsp;&nbsp;<strong>Name:</strong> ".$name."</td>\n";
			echo "<td class=\"cell_left\">\n";
			echo "<img src=\"".DIR_IMAGES_ICONS."/calendar.png\" alt=\"Kalendar\" />&nbsp;";
			echo date("d.m.Y - H:i:s", $date);
			echo "<div class=\"float_right\">\n";
			if(!empty($mail))
				echo "<a href=\"mailto:".$mail."\"><img src=\"".DIR_IMAGES_ICONS."/mail.png\" alt=\"E-Mail\" /></a>&nbsp;\n";
			if(!empty($homepage))
				echo "<a href=\"".$homepage."\"><img src=\"".DIR_IMAGES_ICONS."/homepage.png\" alt=\"Homepage\" /></a>&nbsp;\n";
			echo "</div>\n";
			echo "</td>\n";
			echo "</tr>\n";
			echo "<tr><td class=\"cell_right\" colspan=\"2\">\n";
			echo "<div class=\"word_wrap\">".$entry."</div>\n";
			echo "</td>\n</tr>\n";
			if($show_comment && !empty($comment))
				echo "<tr><td colspan=\"2\" class=\"cell_border\"><strong>Kommentar</strong><br />".$comment."</td></tr>\n";
			break;
		}
		case 2:
		{
			echo "<tr>\n";
			echo "<td class=\"cell_left\" colspan=\"2\">";
			echo "<span class=\"text_small\">\n";
			echo "Eingetragen am <strong>".$weekday[date("w", $date)].", ".date("d.m.Y - H:i:s", $date)."</strong> von <strong>".$name."</strong>\n";
			echo "</span>\n";
			echo "<div class=\"float_right\">\n";
			if(!empty($mail))
				echo "<a href=\"mailto:".$mail."\"><img src=\"".DIR_IMAGES_ICONS."/mail.png\" alt=\"E-Mail\" /></a>&nbsp;\n";
			if(!empty($homepage))
				echo "<a href=\"".$homepage."\"><img src=\"".DIR_IMAGES_ICONS."/homepage.png\" alt=\"Homepage\" /></a>&nbsp;\n";
			echo "</div><br />\n";
			echo "<div class=\"padding word_wrap\">".$entry."</div>\n";
			echo "</td>\n";
			echo "</tr>\n";
			if($show_comment && !empty($comment))
				echo "<tr><td colspan=\"2\" class=\"cell_right\"><strong>Kommentar</strong><br />".$comment."</td></tr>\n";
			break;
		}
		case 3:
		{
			echo "<tr>\n";
			echo "<td class=\"cell_left\"><strong>Name</strong></td>\n";
			echo "<td class=\"cell_right\">\n";
			echo $name;
			echo "</td>\n";
			echo "</tr>\n";
			if(!empty($mail))
			{
				echo "<tr>\n";
				echo "<td class=\"cell_left\"><strong>E-Mail</strong></td>\n";
				echo "<td class=\"cell_right\"><a href=\"mailto:".$mail."\">".$mail."</a></td>\n";
				echo "</tr>\n";
			}
			if(!empty($homepage))
			{
				echo "<tr>\n";
				echo "<td class=\"cell_left\"><strong>Homepage</strong></td>\n";
				echo "<td class=\"cell_right\"><a href=\"".$homepage."\">".$homepage."</a></td>\n";
				echo "</tr>\n";
			}
			echo "<tr><td class=\"cell_left\"><strong>Eintrag</strong></td>\n<td class=\"cell_right\"><div class=\"word_wrap\">".$entry."</div></td></tr>\n";
			echo "<tr><td class=\"cell_left\"><strong>Datum</strong></td><td class=\"cell_right\">".$weekday[date("w", $date)].", ".date("d.m.Y - H:i:s", $date)."</td></tr>\n";
			if($show_comment && !empty($comment))
				echo "<tr><td class=\"cell_left\"><strong>Kommentar</strong></td><td class=\"cell_right\">".$comment."</td></tr>\n";
			break;
		}
	}
}

function send_notification($date, $name, $mail, $homepage, $entry, $ip)
{
	global $settings, $weekday;
	
	$mail_header = "MIME-Version: 1.0\r\n";
	$mail_header .= "From: ".$settings['MAIL_ADDRESS']."\r\n";
	$mail_header .= "X-Mailer: PHP ".phpversion()."\r\n";
	$mail_header .= "Content-type: text/html; charset=utf-8\r\n";
	
	$mail_text = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
	$mail_text .= "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n";
	$mail_text .= "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"de\">\n";
	$mail_text .= "<head>\n";
	$mail_text .= "<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\" />\n";
	$mail_text .= "<style type=\"text/css\">\n";
	$border = $settings['BORDER_WIDTH']."px ".$settings['BORDER_STYLE']." ".$settings['BORDER_COLOR'];
	$mail_text .= "body { color: ".$settings['FONT_COLOR']."; background: ".$settings['COLOR_BACKGROUND']."; font-family: ".$settings['FONT_FAMILY']."; font-size: ".$settings['FONT_SIZE']."pt; }\n";
	$mail_text .= "a { color: ".$settings['LINK_COLOR']."; text-decoration: ".$settings['LINK_STYLE']."; }\n";
	$mail_text .= "a:hover { color: ".$settings['LINK_COLOR_HOVER']."; text-decoration: ".$settings['LINK_STYLE_HOVER']."; }\n";
	$mail_text .= "table { border-collapse: collapse; }\n";
	$mail_text .= "td { padding: 5px; }\n";
	$mail_text .= "#guestbook { background: ".$settings['COLOR_BACKGROUND_CENTER']."; padding: 5px; border: ".$border."; }\n";
	$mail_text .= ".cell_left { border: ".$border."; background: ".$settings['COLOR_CELL_LEFT']."; vertical-align: top; }\n";
	$mail_text .= ".cell_right { border: ".$border."; background: ".$settings['COLOR_CELL_RIGHT']."; vertical-align: top; }\n";
	$mail_text .= ".text_center { text-align: center; }\n";
	$mail_text .= ".underline { text-decoration: underline; }\n";
	$mail_text .= "</style>\n";
	$mail_text .= "</head>\n\n";
	$mail_text .= "<body>\n";
	
	$mail_text .= "<div id=\"guestbook\">\n";
	$mail_text .= "<h1>G&auml;stebuch</h1>\n";
	$mail_text .= "<table>\n";
	$mail_text .= "<tr>\n";
	$mail_text .= "<td class=\"cell_left\"><strong>Name</strong></td>\n";
	$mail_text .= "<td class=\"cell_right\">".$name."</td>\n";
	$mail_text .= "</tr>\n";
	if(!empty($mail))
	{
		if(strpos($mail, "#") !== false)
			$mail = substr($mail, 1);
		$mail_text .= "<tr>\n";
		$mail_text .= "<td class=\"cell_left\"><strong>E-Mail</strong></td>\n";
		$mail_text .= "<td class=\"cell_right\"><a href=\"mailto:".$mail."\">".$mail."</a></td>\n";
		$mail_text .= "</tr>\n";
	}
	if(!empty($homepage))
	{
		$mail_text .= "<tr>\n";
		$mail_text .= "<td class=\"cell_left\"><strong>Homepage</strong></td>\n";
		$mail_text .= "<td class=\"cell_right\"><a href=\"".$homepage."\">".$homepage."</a></td>\n";
		$mail_text .= "</tr>\n";
	}
	if(!empty($ip))
	{
		$mail_text .= "<tr>\n";
		$mail_text .= "<td class=\"cell_left\"><strong>IP-Adresse</strong></td>\n";
		$mail_text .= "<td class=\"cell_right\">".$ip."</td>\n";
		$mail_text .= "</tr>\n";
	}
	$mail_text .= "<tr><td class=\"cell_left\"><strong>Eintrag</strong></td>\n<td class=\"cell_right\">".bb_code($entry, false)."</td></tr>\n";
	$mail_text .= "<tr><td class=\"cell_left\"><strong>Datum</strong></td><td class=\"cell_right\">".$weekday[date("w", $date)].", ".date("d.m.Y - H:i:s", $date)."</td></tr>\n";
	if($settings['MANUAL_ACTIVATION'])
	{
		$mail_text .= "<tr><td colspan=\"2\" class=\"text_center\">\n";
		$mail_text .= "<a href=\"http://".$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME']."?p=unlockmail&pw=".crypt($settings['ADMIN_PASS'])."&key=".$date."\"><strong>freischalten</strong></a>";
		$mail_text .= "&nbsp;&nbsp;&nbsp;\n";
		$mail_text .= "<a href=\"http://".$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME']."?p=unlockmail&pw=".crypt($settings['ADMIN_PASS'])."&key=".$date."&a=d\"><strong>l&ouml;schen</strong></a>";
		$mail_text .= "</td></tr>\n";
	}
	$mail_text .= "</table>\n";
	$mail_text .= "</div>\n";
	$mail_text .= "</body>\n\n";
	$mail_text .= "</html>\n";
	
	mail($settings['MAIL_ADDRESS'], utf8_encode("Neuer Eintrag im Gstebuch"), $mail_text, $mail_header);
}
?>