<?php
header("Content-type: text/css");
include("../data/config.php");

$width_left = round($settings['WIDTH'] / 3);
$width_right = $settings['WIDTH'] - $width_left;
$border = $settings['BORDER_WIDTH']."px ".$settings['BORDER_STYLE']." ".$settings['BORDER_COLOR'];

$ww_width = $width_right - (10 + 2 * $settings['BORDER_WIDTH']);
switch($settings['LAYOUT'])
{
	case 1: $ww_width = $settings['WIDTH'] - (10 + 2 * $settings['BORDER_WIDTH']); break;
	case 2: $ww_width = $settings['WIDTH'] - (20 + 2 * $settings['BORDER_WIDTH']); break;
	case 3: 
		$width_left = round($settings['WIDTH'] / 6);
		$width_right = $settings['WIDTH'] - $width_left;
		$ww_width = $width_right - (10 + 2 * $settings['BORDER_WIDTH']);
		break;
}
if($settings['FONT_SIZE'] > 10)
	$ww_width = ceil($ww_width * 10 / $settings['FONT_SIZE']);
?>
body
{
	color: <?php echo $settings['FONT_COLOR']; ?>;
	background: <?php echo $settings['COLOR_BACKGROUND']; ?>;
	font-family: <?php echo $settings['FONT_FAMILY']; ?>;
	font-size: <?php echo $settings['FONT_SIZE']; ?>pt;
}
img
{
	border: none;
	vertical-align: middle;
}
a
{
	color: <?php echo $settings['LINK_COLOR']; ?>;
	text-decoration: <?php echo $settings['LINK_STYLE']; ?>;
}
a:hover
{
	color: <?php echo $settings['LINK_COLOR_HOVER']; ?>;
	text-decoration: <?php echo $settings['LINK_STYLE_HOVER']; ?>;
}
table
{
	border-collapse: collapse;
}
td, .padding
{
	padding: 5px;
}
input[type=text], input[type=password], input[type=submit], input[type=button], select, textarea
{	
	background-color: <?php echo $settings['COLOR_BACKGROUND_CENTER']; ?>;
	border: <?php echo $border; ?>;
}
hr
{
	width: 75%;
	height: 1px;
	color: <?php echo $settings['BORDER_COLOR']; ?>;
	background-color: <?php echo $settings['BORDER_COLOR']; ?>;
	border: none;  
}

#guestbook
{
	width: <?php echo $settings['WIDTH']; ?>px;
	margin: 0 auto;
	background: <?php echo $settings['COLOR_BACKGROUND_CENTER']; ?>;
	padding: 5px;
	border: <?php echo $border; ?>;
}
#footer_login
{
	width: <?php echo $settings['WIDTH']; ?>px;
	margin: 0 auto;
	padding: 2px;
}

.box_error
{
	color: #9b0f0f;
	font-weight: bold;
	background: #fa8c8c url(../images/icons/error.png) no-repeat 5px 5px;
	padding: 5px 5px 5px 30px;
	border: 1px solid #9b0f0f;
}
.box_access
{
	color: #9b0f0f;
	font-weight: bold;
	background: #fa8c8c url(../images/icons/access_denied.png) no-repeat 5px 5px;
	padding: 5px 5px 5px 30px;
	border: 1px solid #9b0f0f;
}
.box_warning
{
	color: #a06400;
	font-weight: bold;
	background: #fff0b4 url(../images/icons/warning.png) no-repeat 5px 5px;
	padding: 5px 5px 5px 30px;
	border: 1px solid #a06400;
}
.box_success
{
	color: #0f781e;
	font-weight: bold;
	background: #6ee678 url(../images/icons/success.png) no-repeat 5px 5px;
	padding: 5px 5px 5px 30px;
	border: 1px solid #0f781e;
}
.box_info
{
	color: #284696;
	font-weight: bold;
	background: #82bef0 url(../images/icons/info.png) no-repeat 5px 5px;
	padding: 5px 5px 5px 30px;
	border: 1px solid #284696;
}

.text_small
{
	font-size: smaller;
}
.text_center
{
	text-align: center;
}
.text_right
{
	text-align: right;
}
.underline
{
	text-decoration: underline;
}
.uppercase
{
	text-transform: uppercase;
}

.float_left
{
	float: left;
}
.float_right
{
	float: right;
}
.float_clear
{
	clear: both;
}

.fullwidth
{
	width: 100%;
}
.fullwidth99
{
	width: 99%;
}
.cell_left
{
	<?php echo ($settings['LAYOUT'] == 0 || $settings['LAYOUT'] == 3) ? "width: ".$width_left."px;\n" : "\n"; ?>
	border: <?php echo $border; ?>;
	background: <?php echo $settings['COLOR_CELL_LEFT']; ?>;
	vertical-align: top;
}
.word_wrap
{
	width: <?php echo $ww_width; ?>px;
	white-space: pre-wrap;
	white-space: -moz-pre-wrap;
	white-space: -pre-wrap;
	white-space: -o-pre-wrap;
	word-wrap: break-word;
}
.cell_right
{
	border: <?php echo $border; ?>;
	background: <?php echo $settings['COLOR_CELL_RIGHT']; ?>;
	vertical-align: top;
}
.cell_border
{
	border: <?php echo $border; ?>;
}

.dn
{
	display: none;
}