/**
 * tsGuestbook JavaScript-Funktionen
 * 
 * @version    1.0.0
 * @copyright  Copyright (c) 2013 Top-Side.de
 * 
 */
function getSelectedText()
{
	var input = document.getElementById('entry');
	if(typeof document.selection != 'undefined')
	{
		var range = document.selection.createRange();
		return range.text;
	}
	else if(typeof input.selectionStart != 'undefined')
	{
		var start = input.selectionStart;
		var end = input.selectionEnd;
		return input.value.substring(start, end);
	}
	else
		return '';
}

function insert(aTag, eTag)
{
	var input = document.getElementById('entry');
	input.focus();
	if(typeof document.selection != 'undefined')
	{
		var range = document.selection.createRange();
		var insText = range.text;
		range.text = aTag + insText + eTag;
		range = document.selection.createRange();
		if(insText.length == 0)
			range.move('character', -eTag.length);
		else
			range.moveStart('character', aTag.length + insText.length + eTag.length);
		range.select();
	}
	else if(typeof input.selectionStart != 'undefined')
	{
		var start = input.selectionStart;
		var end = input.selectionEnd;
		var insText = input.value.substring(start, end);
		input.value = input.value.substr(0, start) + aTag + insText + eTag + input.value.substr(end);
		var pos;
		if(insText.length == 0)
			pos = start + aTag.length;
		else
			pos = start + aTag.length + insText.length + eTag.length;
		input.selectionStart = pos;
		input.selectionEnd = pos;
	}
	else
	{
		var pos = input.value.length;
		input.value = input.value.substr(0, pos) + aTag + ' ' + eTag + input.value.substr(pos);
	}
}

function bbCodeSmilie(emoticon)
{
	insert(emoticon, '');
}

function bbCodeBold()
{
	insert('[b]', '[/b]');
}

function bbCodeItalic()
{
	insert('[i]', '[/i]');
}

function bbCodeUnderline()
{
	insert('[u]', '[/u]');
}

function bbCodeLink()
{
	link = prompt('Bitte die Link-Url eingeben:', 'http://www.');
	text = getSelectedText();
	if(link != '' && link != 'http://www.' && link != undefined)
	{
		if(text != '')
			insert('[url=' + link + ']', '[/url]');
		else
			insert('[url]' + link + '[/url]', '');
	}
}

function bbCodeImage()
{
	text = prompt('Bitte die Link-Url zur Grafik eingeben:', 'http://');
	if(text != '' && text != 'http://' && text != undefined)
		insert('[img]' + text + '[/img]', '');
}

function randomcode(file)
{
	document.images.captcha.src = file + '?x=' + new Date().getTime();
}