<?php
/**
 * tsGuestbook
 * 
 * @version    2.0.0
 * @author     Markus Nolte
 * @copyright  Copyright (c) 2013 Top-Side.de
 * @license    CC BY-NC-SA 3.0 DE (http://creativecommons.org/licenses/by-nc-sa/3.0/de/)
 * @link       http://www.top-side.de
 * 
 */

define("DIR_DATA", "gb_files/data");
define("DIR_IMAGES_ICONS", "gb_files/images/icons");
define("DIR_IMAGES_SMILEYS", "gb_files/images/smileys");
define("DIR_INCLUDES", "gb_files/includes");
define("DIR_JS", "gb_files/js");
define("FILENAME", basename($_SERVER['PHP_SELF']));

include(DIR_DATA."/config.php");
include(DIR_INCLUDES."/functions.php");

session_start();
$page = (isset($_GET['p'])) ? $_GET['p'] : "index";
if(!isset($_SESSION['login']))
	$_SESSION['login'] = false;
	
echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n";
echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"de\">\n";
echo "<head>\n";
echo "<title>".$settings['GB_TITLE']."</title>\n";
echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\" />\n";
echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"".DIR_INCLUDES."/style.css.php\" />\n";
if($page == "sign" || $page == "edit")
{
	echo "<script type=\"text/javascript\" src=\"".DIR_JS."/jquery.js\"></script>\n";
	echo "<script type=\"text/javascript\" src=\"".DIR_JS."/jquery.blockui.js\"></script>\n";
	echo "<script type=\"text/javascript\" src=\"".DIR_JS."/functions.js\"></script>\n";
}
elseif($page == "settings")
{
	echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"".DIR_INCLUDES."/style_admin.css.php\" />\n";
	echo "<script type=\"text/javascript\" src=\"".DIR_JS."/jquery.js\"></script>\n";
	echo "<script type=\"text/javascript\" src=\"".DIR_JS."/jquery.minicolors.js\"></script>\n";
}
echo "</head>\n\n";
echo "<body>\n";

echo "<noscript><p class=\"box_info\">Um alle Funktionen des G&auml;stebuchs benutzen zu k&ouml;nnen bitte JavaScript aktivieren!</p></noscript>\n";

echo "<div id=\"guestbook\">\n";
echo "<h1 class=\"text_center\">".$settings['GB_TITLE']."</h1>\n";

if($_SESSION['login'])
{
	echo "<div class=\"float_right\">\n";
	echo "<img src=\"".DIR_IMAGES_ICONS."/settings.png\" alt=\"Einstellungen\" />&nbsp;<a href=\"".FILENAME."?p=settings\">Einstellungen</a>\n";
	echo "<img src=\"".DIR_IMAGES_ICONS."/system.png\" alt=\"System\" />&nbsp;<a href=\"".FILENAME."?p=system\">System</a>\n";
	echo "<img src=\"".DIR_IMAGES_ICONS."/password.png\" alt=\"Passwort\" />&nbsp;<a href=\"".FILENAME."?p=password\">Passwort</a>\n";
	if($settings['MANUAL_ACTIVATION'])
		echo "<img src=\"".DIR_IMAGES_ICONS."/unlock.png\" alt=\"Eintr&auml;ge freischalten\" />&nbsp;<a href=\"".FILENAME."?p=unlock\">Eintr&auml;ge freischalten</a>\n";
	echo "<img src=\"".DIR_IMAGES_ICONS."/logout.png\" alt=\"Logout\" />&nbsp;<a href=\"".FILENAME."?p=logout\">Logout</a>\n";
	echo "</div>\n";
}

if($page != "index" && $page != "logout")
	echo "<img src=\"".DIR_IMAGES_ICONS."/back.png\" alt=\"zur&uuml;ck\" />&nbsp;<a href=\"".FILENAME."\">zur&uuml;ck</a><br /><br />\n";

switch($page)
{
	default:
	{
		echo "<img src=\"".DIR_IMAGES_ICONS."/sign.png\" alt=\"eintragen\" />&nbsp;<a href=\"".FILENAME."?p=sign\">eintragen</a>\n";
		$file = array_reverse(file(DIR_DATA."/content"));
		$count = sizeof($file);
		if($count == 0)
			echo "<p class=\"box_info\">Noch keine Eintr&auml;ge vorhanden!</p>\n";
		else
		{			
			$pages = ceil($count / $settings['ENTRIES_PER_PAGE']);
			$current_page = (isset($_GET['page'])) ? $_GET['page'] : 1;
			
			$pages_html = "";
			if($current_page > 1)
				$pages_html .= "<a href=\"".FILENAME."?page=".($current_page - 1)."\">&laquo;</a>&nbsp;\n";
			if($current_page - 1 >= 1)
				$pages_html .= "<a href=\"".FILENAME."?page=1\">1</a>&nbsp;\n";
			if($current_page > 3)
				$pages_html .= "...&nbsp;\n";
			if($current_page - 1 > 1)
				$pages_html .= "<a href=\"".FILENAME."?page=".($current_page - 1)."\">".($current_page - 1)."</a>&nbsp;\n";
			$pages_html .= "<strong>".$current_page."</strong>&nbsp;\n";
			if($current_page + 1 < $pages)
				$pages_html .= "<a href=\"".FILENAME."?page=".($current_page + 1)."\">".($current_page + 1)."</a>&nbsp;\n";
			if($current_page < $pages - 2)
				$pages_html .= "...&nbsp;\n";
			if($current_page + 1 <= $pages)
				$pages_html .= "<a href=\"".FILENAME."?page=".$pages."\">".$pages."</a>&nbsp;\n";
			if($current_page < $pages)
				$pages_html .= "<a href=\"".FILENAME."?page=".($current_page + 1)."\">&raquo;</a>\n";
			
			echo "<p class=\"text_center\">".(($pages > 1) ? $pages_html : "")."</p>\n";
			
			$start = ($current_page - 1) * $settings['ENTRIES_PER_PAGE'];
			$end = $current_page * $settings['ENTRIES_PER_PAGE'];
			if($end > $count)
				$end = $count;
			
			echo "<table class=\"fullwidth\">\n";
			for($i = $start; $i < $end; $i++)
			{
				$item = explode("|@|", $file[$i]);
				display_entry($item, $count - $i);
				if($_SESSION['login'])
				{
					$indexFile = ($count - $i - 1);
					echo "<tr><td colspan=\"2\" class=\"text_right\">\n";
					$comment_text = (empty($item[5])) ? "Kommentar schreiben" : "Kommentar bearbeiten";
					echo "<img src=\"".DIR_IMAGES_ICONS."/comment.png\" title=\"".$comment_text."\" alt=\"Kommentar\" />&nbsp;";
					echo "<a href=\"".FILENAME."?p=comment&amp;i=".$indexFile."&amp;cp=".$current_page."\">".$comment_text."</a>\n";
					echo "<img src=\"".DIR_IMAGES_ICONS."/edit.png\" title=\"Eintrag bearbeiten\" alt=\"Bearbeiten\" />&nbsp;";
					echo "<a href=\"".FILENAME."?p=edit&amp;i=".$indexFile."&amp;cp=".$current_page."\">Eintrag bearbeiten</a>\n";
					echo "<img src=\"".DIR_IMAGES_ICONS."/delete.png\" title=\"Eintrag l&ouml;schen\" alt=\"L&ouml;schen\" />&nbsp;";
					echo "<a href=\"".FILENAME."?p=delete&amp;i=".$indexFile."&amp;cp=".$current_page."\">Eintrag l&ouml;schen</a>\n";
					echo "<br />\n";
					echo "</td></tr>\n";
				}
				if($i < $end - 1)
					echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
			}
			echo "</table>\n";
			
			echo "<p class=\"text_center\">".(($pages > 1) ? $pages_html : "")."</p>\n";
		}
		
		echo "<a class=\"float_left\" href=\"#\" onclick=\"self.scrollTo(0,0)\"><img src=\"".DIR_IMAGES_ICONS."/up.png\" alt=\"Up\" /></a>\n";
		$file = file(DIR_DATA."/hits");
		$hits = $file[0] + 1;
		$handle = fopen(DIR_DATA."/hits", "w");
		fwrite($handle, $hits);
		fclose($handle);
		echo "<div class=\"float_right\">";
		echo "<img src=\"".DIR_IMAGES_ICONS."/statistic.png\" alt=\"Statistik\" />&nbsp;";
		echo number_format($count, 0, ",", ".")." ".(($count == 1) ? "Eintrag" : "Eintr&auml;ge")." | ".number_format($hits, 0, ",", ".")." Aufrufe\n";
		echo "</div><br class=\"float_clear\" />\n";
		break;
	}
	case "sign":
	{
		if(!empty($settings['IPS_BLOCKED']) && in_array($_SERVER['REMOTE_ADDR'], array_map("trim", explode(",", $settings['IPS_BLOCKED']))))
		{
			echo "<div class=\"box_access\">IP-Adresse ist gesperrt!</div>\n";
			break;
		}
		
		if($settings['CAPTCHA'] == 3)
			require_once(DIR_INCLUDES."/recaptchalib.php");
		if(!$_POST)
			$_SESSION['time_start'] = time();
		
		if(isset($_POST['sign']) || isset($_POST['preview']))
		{
			$errors = "";
			if(!preg_match("/^[a-zA-Z0-9\-\/ ]{3,40}$/", $_POST['name']))
				$errors .= "&bull; Name ist ung&uuml;ltig<br />\n";
			if(!preg_match("/^[a-zA-Z0-9]+([-_\.]{0,2}[a-zA-Z0-9])+@[a-zA-Z0-9]+([-_\.]?[a-zA-Z0-9])+\.[a-zA-Z]{2,4}$/", $_POST['email']))
				$errors .= "&bull; E-Mail Adresse ist ung&uuml;ltig<br />\n";
			if($_POST['homepage'] != "http://www." && !preg_match("/^((http:\/\/)(www\.)?[a-z0-9]+([-_\.]?[a-z0-9])+\.[a-z]{2,4}[a-zA-Z0-9|_|-|+|.|\/]*){0,}$/", $_POST['homepage']))
				$errors .= "&bull; Homepage ist ung&uuml;ltig<br />\n";
			$entry = $_POST['entry'] = clean_up($_POST['entry']);
			if(strlen($entry) < 10)
				$errors .= "&bull; Eintrag ist zu kurz<br />\n";
			if(strlen($entry) > 2500)
				$errors .= "&bull; Eintrag ist zu lang<br />\n";
			if(isset($_POST['sign']) && $settings['CAPTCHA'])
			{
				if(($settings['CAPTCHA'] == 1 || $settings['CAPTCHA'] == 2) && trim(strtoupper($_POST['captcha'])) != $_SESSION['captcha'])
					$errors .= "&bull; Falscher Sicherheitscode<br />\n";
				elseif($settings['CAPTCHA'] == 3)
				{
					$resp = recaptcha_check_answer($settings['RECAPTCHA_PRIVATEKEY'], $_SERVER['REMOTE_ADDR'], $_POST['recaptcha_challenge_field'], $_POST['recaptcha_response_field']);
					if(!$resp->is_valid)
						$errors .= "&bull; Falscher Sicherheitscode<br />\n";
				}
			}
			if($settings['BAD_WORDS'] != "")
			{
				$bad_words_array = explode(",", $settings['BAD_WORDS']);
				$bad_words_found_name = "";
				foreach($bad_words_array as $badword)
				{
					$badword = trim($badword);
					if(preg_match("/".$badword."/i", $_POST['name']))
						$bad_words_found_name .= $badword.", ";
				}
				if($bad_words_found_name != "")
					$errors .= "&bull; Name enth&auml;lt gesperrte W&ouml;rter: ".substr($bad_words_found_name, 0, -2)."<br />\n";
				$bad_words_found_entry = "";
				foreach($bad_words_array as $badword)
				{
					$badword = trim($badword);
					if(preg_match("/".$badword."/i", $entry))
						$bad_words_found_entry .= $badword.", ";
				}
				if($bad_words_found_entry != "")
					$errors .= "&bull; Eintrag enth&auml;lt gesperrte W&ouml;rter: ".substr($bad_words_found_entry, 0, -2)."<br />\n";
			}
			if(time() - $_SESSION['time_start'] <= 10)
			{
				$_SESSION['time_start'] = time();
				$errors .= "&bull; Eintrag wurde zu schnell ausgef&uuml;hrt<br />\n";
			}
			if(!empty($_POST['confirm_email']))
				$errors .= "&bull; Eintrag ist ung&uuml;ltig<br />\n";
			if($settings['IMG_UPLOAD'] && isset($_POST['sign']) && empty($errors) && $_FILES['userimage']['name'] != "")
			{
				$file_elements = explode(".", $_FILES['userimage']['name']);
				$file_extension = array_pop($file_elements);
				if(!in_array($file_extension, array_map("trim", explode(",", $settings['IMG_FILE_TYPES']))) || getimagesize($_FILES['userimage']['tmp_name']) == false)
					$errors .= "&bull; Bildupload: ung&uuml;ltiger Dateityp (".$file_extension.")<br />\n";
				if($_FILES['userimage']['size'] > $settings['IMG_MAX_FILESIZE'] * 1024)
					$errors .= "&bull; Bildupload: Datei zu gro&szlig; (".number_format(($_FILES['userimage']['size'] / 1024), 0, ",", ".")." KB)<br />\n";
				list($img_width, $img_height) = getimagesize($_FILES['userimage']['tmp_name']);
				if($img_width > $settings['IMG_MAX_WIDTH'] || $img_height > $settings['IMG_MAX_HEIGHT'])
					$errors .= "&bull; Bildupload: Bild zu gro&szlig; (".$img_width."x".$img_height." Pixel)<br />\n";
			}
			if(isset($_POST['sign']) && empty($errors))
			{
				$reload = reload_lock($settings['RELOAD_TICKS']);
				if($reload > 0)
					$errors .= "&bull; Eintrag erst in ".sprintf("%02d:%02d:%02d", $reload /60 / 60, ($reload / 60) % 60, $reload % 60)." wieder m&ouml;glich<br />\n";
			}
			if(!empty($errors))
				echo "<div class=\"box_warning\">\n".$errors."</div><br />\n";
			else
			{
				$entry = generate_html($entry);
				if(isset($_POST['sign']))
				{
					unset($_SESSION['captcha']);
					unset($_SESSION['time_start']);
					$file = DIR_DATA."/content";
					if($settings['MANUAL_ACTIVATION'])
						$file = DIR_DATA."/content_new";
					$key = time();
					$homepage = ($_POST['homepage'] != "http://www.") ? $_POST['homepage'] : "";
					$email = ((isset($_POST['hidemail'])) ? "#" : "").$_POST['email'];
					if($settings['IMG_UPLOAD'] && $_FILES['userimage']['name'] != "")
					{
						$img_name = md5(uniqid(mt_rand(), true)).".".$file_extension;
						move_uploaded_file($_FILES['userimage']['tmp_name'], "gb_files/images_upload/".$img_name);
						$entry .= "<br /><br />[img]gb_files/images_upload/".$img_name."[/img]";
					}
					$input = $key."|@|".$_POST['name']."|@|".$email."|@|".$homepage."|@|".$entry."|@||@|".$_SERVER['REMOTE_ADDR']."|@|\n";
					$handle = fopen($file, "a");
					fwrite($handle, $input);
					fclose($handle);
					if($settings['MAIL_INFO'])
						send_notification($key, $_POST['name'], $_POST['email'], $homepage, $entry, $_SERVER['REMOTE_ADDR']);
					if($settings['MANUAL_ACTIVATION'])
						echo "<div class=\"box_success\">Eintrag erfolgreich, wird nach Freischaltung durch Betreiber sichtbar.</div>";
					else
						echo "<script type=\"text/javascript\">location.href='".FILENAME."';</script>";
					break;
				}
				elseif(isset($_POST['preview']))
				{
					$key = time();
					$homepage = ($_POST['homepage'] != "http://www.") ? $_POST['homepage'] : "";
					$email = ((isset($_POST['hidemail'])) ? "#" : "").$_POST['email'];
					$item = array($key, $_POST['name'], $email, $homepage, $entry, "");
					
					echo "<table id=\"preview\" style=\"display:none\">\n";
					display_entry($item, sizeof(file(DIR_DATA."/content")) + 1);
					echo "<tr><td colspan=\"2\" class=\"text_right\"><input type=\"button\" id=\"close_preview\" value=\"Vorschau schlie&szlig;en\" /></td></tr>\n";
					echo "</table>\n";
					
					echo "<script type=\"text/javascript\"><!--\n";
					echo "$.blockUI({ message: $('#preview'), css: { width: '".$settings['WIDTH']."px', left: ($(window).width() - ".$settings['WIDTH'].") / 2 + 'px', top: '100px', textAlign: 'left' } });\n";
					echo "$('#close_preview').click(function() { $.unblockUI(); });\n";
					echo "--></script>";
				}
			}
		}
			
		echo "<form action=\"".FILENAME."?p=sign\" method=\"post\"".(($settings['IMG_UPLOAD']) ? " enctype=\"multipart/form-data\"" : "").">\n";
		echo "<table class=\"fullwidth\">\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>Name</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"name\" size=\"40\" maxlength=\"40\"".(isset($_POST['name']) ? " value=\"".$_POST['name']."\"" : "")." /></td>\n</tr>\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>E-Mail Adresse</strong></td>\n";
		echo "<td class=\"cell_right\">\n";
		echo "<input type=\"text\" name=\"email\" size=\"40\" maxlength=\"50\"".(isset($_POST['email']) ? " value=\"".$_POST['email']."\"" : "")." /><br />\n";
		echo "<input type=\"checkbox\" name=\"hidemail\" value=\"1\"".(isset($_POST['hidemail']) ? " checked=\"checked\"" : "")." />E-Mail Adresse nicht &ouml;ffentlich anzeigen\n";
		echo "<input type=\"text\" name=\"confirm_email\" size=\"40\" class=\"dn\"".(isset($_POST['confirm_email']) ? " value=\"".$_POST['confirm_email']."\"" : "")." />\n";
		echo "</td>\n</tr>\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>Homepage</strong>&nbsp;<span class=\"text_small\">(optional)</span></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"homepage\" size=\"40\" maxlength=\"50\" value=\"".(isset($_POST['homepage']) ? $_POST['homepage'] : "http://www.")."\" /></td>\n</tr>\n";
		echo "<tr>\n<td class=\"cell_left\">\n<strong>Eintrag</strong></td>\n";
		echo "<td class=\"cell_right\">\n";
		if($settings['BBCODES_ENABLED'])
		{
			echo "<a href=\"#\" onclick=\"bbCodeBold()\"><img src=\"".DIR_IMAGES_ICONS."/font_bold.png\" alt=\"fett\" /></a>&nbsp;\n";
			echo "<a href=\"#\" onclick=\"bbCodeItalic()\"><img src=\"".DIR_IMAGES_ICONS."/font_italic.png\" alt=\"kursiv\" /></a>&nbsp;\n";
			echo "<a href=\"#\" onclick=\"bbCodeUnderline()\"><img src=\"".DIR_IMAGES_ICONS."/font_underline.png\" alt=\"unterstrichen\" /></a>&nbsp;\n";
			echo "<a href=\"#\" onclick=\"bbCodeLink()\"><img src=\"".DIR_IMAGES_ICONS."/link.png\" alt=\"Link\" /></a>&nbsp;\n";
			echo "<a href=\"#\" onclick=\"bbCodeImage()\"><img src=\"".DIR_IMAGES_ICONS."/image.png\" alt=\"Bild\" /></a>\n";
			echo "<br />\n";
		}
		echo "<textarea name=\"entry\" id=\"entry\" class=\"fullwidth99\" cols=\"50\" rows=\"10\">".(isset($_POST['entry']) ? $_POST['entry'] : "")."</textarea>\n";
		if($settings['SMILEYS_ENABLED'])
		{
			$i = 0;
			foreach($smileys as $shortcut => $name)
			{
				if($i % 10 == 0)
					echo "<br />\n";
				echo "<a href=\"#\" onclick=\"bbCodeSmilie(' ".$shortcut."')\"><img src=\"".DIR_IMAGES_SMILEYS."/".$name.".png\" alt=\"".$shortcut."\" /></a>&nbsp;\n";
				$i++;
			}
		}
		echo "</td>\n</tr>\n";
		if($settings['IMG_UPLOAD'])
		{
			echo "<tr>\n";
			echo "<td class=\"cell_left\"><strong>Bildupload</strong><br /><span class=\"text_small\">(wird an den Eintrag angeh&auml;ngt)</span></td>\n";
			echo "<td class=\"cell_right\">\n";
			echo "<input type=\"file\" name=\"userimage\" /><br />\n";
			$file_types = implode("/", array_map("trim", explode(",", $settings['IMG_FILE_TYPES'])));
			echo "<span class=\"text_small\">(".$file_types.", maximal ".number_format(($settings['IMG_MAX_FILESIZE']), 0, ",", ".")." KB, ".$settings['IMG_MAX_WIDTH']."x".$settings['IMG_MAX_HEIGHT']." Pixel)</span>\n";
			echo "</td>\n";
			echo "</tr>\n";
		}
		switch($settings['CAPTCHA'])
		{
			case 1:
			{
				echo "<tr>\n";
				echo "<td class=\"cell_left\"><strong>Sicherheitscode</strong></td>\n";
				echo "<td class=\"cell_right\">\n";
				echo "<table>\n";
				echo "<tr><td colspan=\"2\">\n";
				echo "<img src=\"".DIR_INCLUDES."/captcha.php?".session_name()."=".session_id()."\" id=\"captcha\" onclick=\"randomcode('".DIR_INCLUDES."/captcha.php')\" alt=\"Sicherheitscode\" /><br />\n";
				echo "</td></tr>\n";
				echo "<tr>\n";
				echo "<td>\n";
				echo "Code: <input type=\"text\" name=\"captcha\" class=\"uppercase\" size=\"10\" maxlength=\"5\" />\n";
				echo "<input type=\"hidden\" name=\"".session_name()."\" value=\"".session_id()."\" />\n";
				echo "</td>\n";
				echo "<td class=\"text_right\"><img src=\"".DIR_IMAGES_ICONS."/refresh.png\" onclick=\"randomcode('".DIR_INCLUDES."/captcha.php')\" alt=\"Neuer Sicherheitscode\" /></td>\n";
				echo "</tr>\n";
				echo "</table>\n";
				echo "</td>\n";
				echo "</tr>\n";
				break;
			}
			case 2:
			{
				echo "<tr>\n";
				echo "<td class=\"cell_left\"><strong>Sicherheitscode</strong></td>\n";
				echo "<td class=\"cell_right\">\n";
				echo "<table>\n";
				echo "<tr><td colspan=\"2\">\n";
				echo "<img src=\"".DIR_INCLUDES."/calccaptcha.php?".session_name()."=".session_id()."\" id=\"captcha\" onclick=\"randomcode('".DIR_INCLUDES."/calccaptcha.php')\" alt=\"Sicherheitscode\" /><br />\n";
				echo "</td></tr>\n";
				echo "<tr>\n";
				echo "<td>\n";
				echo "Ergebnis: <input type=\"text\" name=\"captcha\" size=\"1\" maxlength=\"2\" />\n";
				echo "<input type=\"hidden\" name=\"".session_name()."\" value=\"".session_id()."\" />\n";
				echo "</td>\n";
				echo "<td class=\"text_right\"><img src=\"".DIR_IMAGES_ICONS."/refresh.png\" onclick=\"randomcode('".DIR_INCLUDES."/calccaptcha.php')\" alt=\"Neuer Sicherheitscode\" /></td>\n";
				echo "</tr>\n";
				echo "</table>\n";
				echo "</td>\n";
				echo "</tr>\n";
				break;
			}
			case 3:
			{
				echo "<tr>\n";
				echo "<td class=\"cell_left\"><strong>Sicherheitscode</strong></td>\n";
				echo "<td class=\"cell_right\">\n";
				echo "<script type=\"text/javascript\">var RecaptchaOptions = { theme: '".$settings['RECAPTCHA_THEME']."', lang: 'de' };</script>\n";
				echo recaptcha_get_html($settings['RECAPTCHA_PUBLICKEY'])."\n";
				echo "</td>\n";
				echo "</tr>\n";
				break;
			}
		}
		echo "<tr><td colspan=\"2\" class=\"text_center\">\n";
		echo "<input type=\"submit\" name=\"sign\" value=\"Eintragen\" />\n";
		echo "<input type=\"submit\" name=\"preview\" value=\"Vorschau\" />\n";
		echo "<input type=\"button\" value=\"Abbruch\" onclick=\"location.href='".FILENAME."'\" />\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		break;
	}
	case "login":
	{
		if(isset($_POST['login']))
		{
			if($_POST['passwort'] == $settings['ADMIN_PASS'])
			{
				$_SESSION['login'] = true;
				echo "<script type=\"text/javascript\">location.href='".FILENAME."';</script>";
			}
			else
				echo "<div class=\"box_error\">Login fehlerhaft. Falsches Passwort!</div><br />\n";
		}
		
		echo "<form action=\"".FILENAME."?p=login\" method=\"post\">\n";
		echo "<table class=\"fullwidth\">\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Passwort</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"password\" name=\"passwort\" size=\"25\" maxlength=\"30\" /></td>\n";
		echo "</tr>\n";
		echo "<tr><td colspan=\"2\" class=\"text_center\"><input type=\"submit\" name=\"login\" value=\"Login\" /></td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		break;
	}
	case "logout":
	{
		session_destroy();
		echo "<script type=\"text/javascript\">location.href='".FILENAME."';</script>";
		break;
	}
	case "settings":
	{
		if(!$_SESSION['login'])
		{
			echo "<div class=\"box_access\">Zugriff verweigert!</div>\n";
			break;
		}
		
		if(isset($_POST['settings_save']))
		{
			$settings['GB_TITLE'] = replace_umlaute($_POST['title']);
			$settings['ENTRIES_PER_PAGE'] = intval($_POST['entries_per_page']);
			$settings['WIDTH'] = intval($_POST['width']);
			$settings['LAYOUT'] = intval($_POST['layout']);
			$settings['SHOW_LOGIN_LINK'] = (isset($_POST['show_login_link']) ? true : false);
			$settings['SMILEYS_ENABLED'] = (isset($_POST['smileys_enabled']) ? true : false);
			$settings['BBCODES_ENABLED'] = (isset($_POST['bbcodes_enabled']) ? true : false);
			$settings['IMG_MAX_WIDTH'] = intval($_POST['img_max_width']);
			$settings['IMG_MAX_HEIGHT'] = intval($_POST['img_max_height']);
			$settings['IMG_UPLOAD'] = (isset($_POST['img_upload']) ? true : false);
			$settings['IMG_MAX_FILESIZE'] = intval($_POST['img_max_filesize']);
			$settings['IMG_FILE_TYPES'] = $_POST['img_file_types'];
			$settings['RELOAD_TICKS'] = intval($_POST['reload_ticks']);
			$settings['IPS_BLOCKED'] = $_POST['ips_blocked'];
			$settings['BAD_WORDS'] = $_POST['bad_words'];
			$settings['CAPTCHA'] = intval($_POST['captcha']);
			$settings['RECAPTCHA_PUBLICKEY'] = $_POST['recaptcha_publickey'];
			$settings['RECAPTCHA_PRIVATEKEY'] = $_POST['recaptcha_privatekey'];
			$settings['RECAPTCHA_THEME'] = $_POST['recaptcha_theme'];
			$settings['MANUAL_ACTIVATION'] = (isset($_POST['manual_activation']) ? true : false);
			$settings['MAIL_INFO'] = (isset($_POST['mail_info']) ? true : false);
			$settings['MAIL_ADDRESS'] = $_POST['mail_address'];
			$settings['COLOR_BACKGROUND'] = $_POST['color_background'];
			$settings['COLOR_BACKGROUND_CENTER'] = $_POST['color_background_center'];
			$settings['COLOR_CELL_LEFT'] = $_POST['color_cell_left'];
			$settings['COLOR_CELL_RIGHT'] = $_POST['color_cell_right'];
			$settings['FONT_COLOR'] = $_POST['font_color'];
			$settings['FONT_FAMILY'] = $_POST['font_family'];
			$settings['FONT_SIZE'] = intval($_POST['font_size']);
			$settings['LINK_COLOR'] = $_POST['link_color'];
			$settings['LINK_COLOR_HOVER'] = $_POST['link_color_hover'];
			$settings['LINK_STYLE'] = $_POST['link_style'];
			$settings['LINK_STYLE_HOVER'] = $_POST['link_style_hover'];
			$settings['BORDER_WIDTH'] = (intval($_POST['border_width']) <= 10) ? intval($_POST['border_width']) : 10;
			$settings['BORDER_STYLE'] = $_POST['border_style'];
			$settings['BORDER_COLOR'] = $_POST['border_color'];
			$input = "<?php\n";
			$input .= "\$settings = ".var_export($settings, true).";\n";
			$input .= "?>";
			$handle = fopen(DIR_DATA."/config.php", "w");
			fwrite($handle, $input);
			fclose($handle);
			echo "<div class=\"box_success\">Einstellungen gespeichert.</div><br />\n";;
		}
		
		$recaptcha_themes = array("red" => "rot", "white" => "wei&szlig;-grau", "blackglass" => "schwarz", "clean" => "klar-wei&szlig;");
		$layouts = array(0 => "2-Spalten-Layout", 1 => "2-Zeilen-Layout", 2 => "Box-Layout", 3 => "Tabellen-Layout");
		$link_styles = array("underline" => "unterstrichen", "overline" => "&uuml;berstrichen", "line-through" => "durchgestrichen", "none" => "keine");
		$border_styles = array("solid" => "durchgezogen", "dotted" => "gepunktet", "dashed" => "gestrichelt", "none" => "keine");
		
		echo "<form action=\"".FILENAME."?p=settings\" method=\"post\">\n";
		echo "<table class=\"fullwidth\">\n";
		echo "<tr><td colspan=\"2\">Allgemeine Einstellungen</td></tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Titel</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"title\" size=\"40\" value=\"".$settings['GB_TITLE']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Eintr&auml;ge pro Seite</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"entries_per_page\" size=\"5\" value=\"".$settings['ENTRIES_PER_PAGE']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Breite in Pixel</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"width\" size=\"5\" value=\"".$settings['WIDTH']."\" /> px</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Layout</strong></td>\n";
		echo "<td class=\"cell_right\"><select name=\"layout\" size=\"1\">\n";
		foreach($layouts as $layout => $layout_name)
			echo "<option value=\"".$layout."\"".(($settings['LAYOUT'] == $layout) ? " selected=\"selected\"" : "").">".$layout_name."</option>\n";
		echo "</select></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Login-Link anzeigen</strong><br /><span class=\"text_small\">(unteres Seitenende links)</span></td>\n";
		echo "<td class=\"cell_right\"><input type=\"checkbox\" name=\"show_login_link\" value=\"1\"".(($settings['SHOW_LOGIN_LINK']) ? " checked=\"checked\"" : "")." /></td>\n";
		echo "</tr>\n";
		
		echo "<tr><td colspan=\"2\">Eintragsformular Einstellungen</td></tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Smileys</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"checkbox\" name=\"smileys_enabled\" value=\"1\"".(($settings['SMILEYS_ENABLED']) ? " checked=\"checked\"" : "")." /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>BB-Codes</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"checkbox\" name=\"bbcodes_enabled\" value=\"1\"".(($settings['BBCODES_ENABLED']) ? " checked=\"checked\"" : "")." /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Maximale Bildgr&ouml;&szlig;e</strong></td>\n";
		echo "<td class=\"cell_right\">\n";
		echo "<table>\n";
		echo "<tr><td>Breite in Pixel</td><td><input type=\"text\" name=\"img_max_width\" size=\"5\" value=\"".$settings['IMG_MAX_WIDTH']."\" /> px</td></tr>\n";
		echo "<tr><td>H&ouml;he in Pixel</td><td><input type=\"text\" name=\"img_max_height\" size=\"5\" value=\"".$settings['IMG_MAX_HEIGHT']."\" /> px</td></tr>\n";
		echo "</table>\n";
		echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Bildupload</strong></td>\n";
		echo "<td class=\"cell_right\">\n";
		$js = "(this.checked) ? document.getElementById('divImgUpload').style.display='block':document.getElementById('divImgUpload').style.display='none';";
		echo "<input type=\"checkbox\" name=\"img_upload\" value=\"1\"".(($settings['IMG_UPLOAD']) ? " checked=\"checked\"" : "")." onclick=\"".$js."\" />\n";
		echo "<div id=\"divImgUpload\" style=\"display: ".(($settings['IMG_UPLOAD']) ? "block" : "none")."\">\n";
		echo "<table>\n";
		echo "<tr><td>maximale Dateigr&ouml;&szlig;e</td>";
		echo "<td><input type=\"text\" name=\"img_max_filesize\" size=\"5\" value=\"".$settings['IMG_MAX_FILESIZE']."\" /> Kilobyte (max. ".(ini_get("upload_max_filesize") * 1024).")</td></tr>\n";
		echo "<tr><td>erlaubte Dateitypen</td><td><input type=\"text\" name=\"img_file_types\" size=\"25\" value=\"".$settings['IMG_FILE_TYPES']."\" /></td></tr>\n";
		echo "</table>\n";
		if(substr(sprintf("%o", fileperms("gb_files/images_upload")), -4) != "0777")
			echo "<div class=\"box_warning\">Der Ordner \"gb_files/images_upload\" ben&ouml;tigt Rechte (chmod) 777!</div>\n";
		echo "</div>\n";
		echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Reload- / IP-Sperre</strong><br /></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"reload_ticks\" size=\"5\" value=\"".$settings['RELOAD_TICKS']."\" /> Sekunden</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Gesperrte IP-Adressen</strong><br /><span class=\"text_small\">(IP-Adressen mit Kommas trennen)</span></td>\n";
		echo "<td class=\"cell_right\"><textarea name=\"ips_blocked\" cols=\"30\" rows=\"3\">".$settings['IPS_BLOCKED']."</textarea></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Sicherheitscode</strong><br /><span class=\"text_small\">(Captcha)</span></td>\n";
		echo "<td class=\"cell_right\"><select name=\"captcha\" size=\"1\">\n";
		$js = "document.getElementById('divReCaptcha').style.display=";
		echo "<option value=\"0\" onclick=\"".$js."'none';\"";if($settings['CAPTCHA']==0)echo" selected=\"selected\"";echo">keinen</option>\n";
		echo "<option value=\"1\" onclick=\"".$js."'none';\"";if($settings['CAPTCHA']==1)echo" selected=\"selected\"";echo">Code-Eingabe</option>\n";
		echo "<option value=\"2\" onclick=\"".$js."'none';\"";if($settings['CAPTCHA']==2)echo" selected=\"selected\"";echo">Rechenaufgabe</option>\n";
		echo "<option value=\"3\" onclick=\"".$js."'block';\"";if($settings['CAPTCHA']==3)echo" selected=\"selected\"";echo">reCAPTCHA</option>\n";
		echo "</select>\n";
		echo "<br /><br />\n";
		echo "<div id=\"divReCaptcha\" style=\"display: ".(($settings['CAPTCHA'] == 3) ? "block" : "none")."\">\n";
		echo "<a href=\"http://www.google.com/recaptcha/whyrecaptcha\">reCAPTCHA Anmeldung</a><br /><br />\n";
		echo "Public-Key<br /><input type=\"text\" name=\"recaptcha_publickey\" size=\"55\" value=\"".$settings['RECAPTCHA_PUBLICKEY']."\" /><br />\n";
		echo "Private-Key<br /><input type=\"text\" name=\"recaptcha_privatekey\" size=\"55\" value=\"".$settings['RECAPTCHA_PRIVATEKEY']."\" /><br />\n";
		echo "Farbschema<br /><select name=\"recaptcha_theme\" size=\"1\">\n";
		foreach($recaptcha_themes as $recaptcha_theme => $recaptcha_theme_name)
			echo "<option value=\"".$recaptcha_theme."\"".(($settings['RECAPTCHA_THEME'] == $recaptcha_theme) ? " selected=\"selected\"" : "").">".$recaptcha_theme_name."</option>\n";
		echo "</select>\n";
		echo "</div>\n";
		echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Badword-Filter (Name und Eintrag)</strong><br /><span class=\"text_small\">(W&ouml;rter mit Kommas trennen)</span></td>\n";
		echo "<td class=\"cell_right\"><textarea name=\"bad_words\" cols=\"30\" rows=\"3\">".$settings['BAD_WORDS']."</textarea></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Manuelle Freischaltung der Eintr&auml;ge</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"checkbox\" name=\"manual_activation\" value=\"1\"".(($settings['MANUAL_ACTIVATION']) ? " checked=\"checked\"" : "")." /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>E-Mail bei neuem Eintrag</strong></td>\n";
		echo "<td class=\"cell_right\">\n";
		$js = "(this.checked) ? document.getElementById('divMailAddress').style.display='block':document.getElementById('divMailAddress').style.display='none';";
		echo "<input type=\"checkbox\" name=\"mail_info\" value=\"1\"".(($settings['MAIL_INFO']) ? " checked=\"checked\"" : "")." onclick=\"".$js."\" />\n";
		echo "<div id=\"divMailAddress\" style=\"display: ".(($settings['MAIL_INFO']) ? "block" : "none")."\">\n";
		echo "E-Mail Adresse<br /><input type=\"text\" name=\"mail_address\" size=\"40\" value=\"".$settings['MAIL_ADDRESS']."\" />\n";
		echo "</div>\n";
		echo "</td>\n";
		echo "</tr>\n";

		echo "<tr><td colspan=\"2\">Farben</td></tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Hintergrund</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" class=\"colorinput\" name=\"color_background\" size=\"10\" value=\"".$settings['COLOR_BACKGROUND']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Hintergrund (Mitte)</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" class=\"colorinput\" name=\"color_background_center\" size=\"10\" value=\"".$settings['COLOR_BACKGROUND_CENTER']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Linke Zellen</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" class=\"colorinput\" name=\"color_cell_left\" size=\"10\" value=\"".$settings['COLOR_CELL_LEFT']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Rechte Zellen</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" class=\"colorinput\" name=\"color_cell_right\" size=\"10\" value=\"".$settings['COLOR_CELL_RIGHT']."\" /></td>\n";
		echo "</tr>\n";
		
		echo "<tr><td colspan=\"2\">Schrift</td></tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Farbe</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" class=\"colorinput\" name=\"font_color\" size=\"10\" value=\"".$settings['FONT_COLOR']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Art</strong><br /><span class=\"text_small\">(z.B.: Arial, Helvetica, Sans-Serif, Verdana)</span></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"font_family\" size=\"10\" value=\"".$settings['FONT_FAMILY']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Gr&ouml;&szlig;e in Punkten</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"font_size\" size=\"5\" value=\"".$settings['FONT_SIZE']."\" /> pt</td>\n";
		echo "</tr>\n";
		
		echo "<tr><td colspan=\"2\">Links</td></tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Farbe</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" class=\"colorinput\" name=\"link_color\" size=\"10\" value=\"".$settings['LINK_COLOR']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Farbe (Hover)</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" class=\"colorinput\" name=\"link_color_hover\" size=\"10\" value=\"".$settings['LINK_COLOR_HOVER']."\" /></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Textdekoration</strong></td>\n";
		echo "<td class=\"cell_right\"><select name=\"link_style\" size=\"1\">\n";
		foreach($link_styles as $link_style => $link_style_name)
			echo "<option value=\"".$link_style."\"".(($settings['LINK_STYLE'] == $link_style) ? " selected=\"selected\"" : "").">".$link_style_name."</option>\n";
		echo "</select></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Textdekoration (Hover)</strong></td>\n";
		echo "<td class=\"cell_right\"><select name=\"link_style_hover\" size=\"1\">\n";
		foreach($link_styles as $link_style_hover => $link_style_hover_name)
			echo "<option value=\"".$link_style_hover."\"".(($settings['LINK_STYLE_HOVER'] == $link_style_hover) ? " selected=\"selected\"" : "").">".$link_style_hover_name."</option>\n";
		echo "</select></td>\n";
		echo "</tr>\n";
		
		echo "<tr><td colspan=\"2\">Rahmen</td></tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Breite in Pixel</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"border_width\" size=\"5\" value=\"".$settings['BORDER_WIDTH']."\" /> px</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Linienart</strong></td>\n";
		echo "<td class=\"cell_right\"><select name=\"border_style\" size=\"1\">\n";
		foreach($border_styles as $border_style => $border_style_name)
			echo "<option value=\"".$border_style."\"".(($settings['BORDER_STYLE'] == $border_style) ? " selected=\"selected\"" : "").">".$border_style_name."</option>\n";
		echo "</select></td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
		echo "<td class=\"cell_left\"><strong>Farbe</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" class=\"colorinput\" name=\"border_color\" size=\"10\" value=\"".$settings['BORDER_COLOR']."\" /></td>\n";
		echo "</tr>\n";
			
		echo "<tr><td colspan=\"2\" class=\"text_center\">\n";
		echo "<input type=\"submit\" name=\"settings_save\" value=\"Einstellungen speichern\" />\n";
		echo "<input type=\"button\" value=\"&Auml;nderungen verwerfen\" onclick=\"location.href='".FILENAME."?p=settings'\" />\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		break;
	}
	case "system":
	{
		echo "<table class=\"fullwidth\">\n";
		echo "<tr><td colspan=\"2\">tsGuestbook</td></tr>\n";
		echo "<tr><td class=\"cell_left\"><strong>Version</strong></td>";
		echo "<td class=\"cell_right\">2.0.0 (<a href=\"http://www.top-side.de/update.php?s=tsGuestbook&amp;v=2.0.0\">Update verf&uuml;gbar?</a>)</td></tr>\n";
		echo "<tr><td colspan=\"2\">Statistik</td></tr>\n";
		echo "<tr><td class=\"cell_left\"><strong>Eintr&auml;ge</strong></td><td class=\"cell_right\">".number_format(sizeof(file(DIR_DATA."/content")), 0, "", ".")."</td></tr>\n";
		$file_hits = file(DIR_DATA."/hits");
		echo "<tr><td class=\"cell_left\"><strong>Aufrufe</strong></td><td class=\"cell_right\">".number_format($file_hits[0], 0, "", ".")."</td></tr>\n";
		echo "<tr><td class=\"cell_left\"><strong>Gr&ouml;&szlig;e der Datendatei</strong></td><td class=\"cell_right\">".number_format((filesize(DIR_DATA."/content") / 1024), 2, ",", ".")." KB</td></tr>\n";
		echo "<tr><td colspan=\"2\">Server</td></tr>\n";
		echo "<tr><td class=\"cell_left\"><strong>Betriebssystem</strong></td><td class=\"cell_right\">".PHP_OS."</td></tr>\n";
		$webserver = preg_split("/[\/ ]/", $_SERVER['SERVER_SOFTWARE']);
		echo "<tr><td class=\"cell_left\"><strong>Webserver</strong></td><td class=\"cell_right\">".$webserver[0]." ".$webserver[1]."</td></tr>\n";
		echo "<tr><td class=\"cell_left\"><strong>PHP Version</strong></td><td class=\"cell_right\">".phpversion()."</td></tr>\n";
		echo "<tr><td class=\"cell_left\"><strong>GD Library</strong><br /><span class=\"text_small\">(f&uuml;r Sicherheitscode notwendig)</span></td>";
		$gd_info = gd_info();
		echo "<td class=\"cell_right\">".((extension_loaded("gd") && function_exists("gd_info")) ? "installiert<br />Version: ".$gd_info['GD Version'] : "nicht installiert" )."</td></tr>\n";
		echo "</table>\n";
		break;
	}
	case "password":
	{
		if(!$_SESSION['login'])
		{
			echo "<div class=\"box_access\">Zugriff verweigert!</div>\n";
			break;
		}
		
		if(isset($_POST['password_save']))
		{
			$error = "";
			if($_POST['password_old'] != $settings['ADMIN_PASS'])
				$error .= "&bull; altes Passwort nicht korrekt<br />\n";
			if($_POST['password_new1'] == "")
				$error .= "&bull; kein neues Passwort angegeben<br />\n";
			if($_POST['password_new2'] == "")
				$error .= "&bull; kein neues Passwort (Wiederholung) angegeben<br />\n";
			if($_POST['password_new1'] != $_POST['password_new2'])
				$error .= "&bull; neues Passwort und Wiederholung stimmen nicht &uuml;berein<br />\n";
			if($error == "")
			{
				$settings['ADMIN_PASS'] = $_POST['password_new1'];
				$input = "<?php\n";
				$input .= "\$settings = ".var_export($settings, true).";\n";
				$input .= "?>";
				$handle = fopen(DIR_DATA."/config.php", "w");
				fwrite($handle, $input);
				fclose($handle);
				echo "<div class=\"box_success\">Passwort gespeichert.</div>\n";
				break;
			}
			else
				echo "<div class=\"box_warning\">\n".$error."</div><br />\n";
		}
		
		echo "<form action=\"".FILENAME."?p=password\" method=\"post\">\n";
		echo "<table class=\"fullwidth\">\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>altes Passwort</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"password\" name=\"password_old\" size=\"25\" /></td>\n</tr>\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>neues Passwort</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"password\" name=\"password_new1\" size=\"25\" /></td>\n</tr>\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>neues Passwort wiederholen</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"password\" name=\"password_new2\" size=\"25\" /></td>\n</tr>\n";
		echo "<tr><td colspan=\"2\" class=\"text_center\">\n";
		echo "<input type=\"submit\" name=\"password_save\" value=\"Passwort speichern\" /></td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		break;
	}
	case "unlock":
	{
		if(!$_SESSION['login'])
		{
			echo "<div class=\"box_access\">Zugriff verweigert!</div>\n";
			break;
		}
		
		$file = array_reverse(file(DIR_DATA."/content_new"));
		
		if(isset($_POST['unlock']))
		{
			if(isset($_POST['items_unlock']))
			{
				for($i = 0; $i < sizeof($_POST['items_unlock']); $i++)
					insert_entry($file[$_POST['items_unlock'][$i]]);
			}
			$file_clear = fopen(DIR_DATA."/content_new", "w+");
			fclose($file_clear);
			echo "<div class=\"box_success\">Eintr&auml;ge freigeschaltet bzw. gel&ouml;scht.</div>\n";
			break;
		}
		
		$count = sizeof($file);
		if($count == 0)
			echo "<p class=\"box_info\">Keine neuen Eintr&auml;ge vorhanden!</p>\n";
		else
		{
			echo "<script type=\"text/javascript\">\n";
			echo "function checkUncheck() { var checkboxes = document.getElementsByName('items_unlock[]'); for(var i = 0; i < checkboxes.length; i++) checkboxes[i].checked = !checkboxes[i].checked; }\n";
			echo "</script>\n";
			echo "<form action=\"".FILENAME."?p=unlock\" method=\"post\">\n";
			echo "<table class=\"fullwidth\">\n";
			echo "<tr><td colspan=\"2\"><input type=\"button\" onclick=\"checkUncheck()\" value=\"alle ausw&auml;hlen\" /></td></tr>\n";
			for($i = 0; $i < $count; $i++)
			{
				echo "<tr><td colspan=\"2\" class=\"cell_border\">\n";
				echo "<input type=\"checkbox\" name=\"items_unlock[]\" value=\"".$i."\" checked=\"checked\" /> freischalten\n";
				echo "</td></tr>\n";
				$item = explode("|@|", $file[$i]);
				display_entry($item, $count - $i);
				if($i < $count - 1)
					echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
			}
			echo "<tr><td colspan=\"2\"><input type=\"button\" onclick=\"checkUncheck()\" value=\"alle ausw&auml;hlen\" /></td></tr>\n";
			echo "<tr><td colspan=\"2\" class=\"text_center\">\n";
			echo "<input type=\"submit\" name=\"unlock\" value=\"Eintr&auml;ge freischalten / l&ouml;schen\" /></td></tr>\n";
			echo "</table>\n";
			echo "</form>\n";
		}
		break;
	}
	case "unlockmail":
	{
		if($_GET['pw'] == crypt($settings['ADMIN_PASS'], $_GET['pw']))
		{
			$file = file(DIR_DATA."/content_new");
			$key_found = false;
			for($i = 0; $i < sizeof($file); $i++)
			{
				$item = explode("|@|", $file[$i]);
				if($item[0] == $_GET['key'])
				{
					$key_found = true;
					if(!isset($_GET['a']) || $_GET['a'] != "d")
						insert_entry($file[$i]);
					$file[$i] = "";
					$file_delete = fopen(DIR_DATA."/content_new", "w");
					fputs($file_delete, implode("", $file));
					fclose($file_delete);
					break;
				}
			}
			if($key_found)
				echo "<div class=\"box_success\">Eintrag ".((!isset($_GET['a']) || $_GET['a'] != "d") ? "freigeschaltet" : "gel&ouml;scht").".</div>\n";
			else
				echo "<div class=\"box_error\">Eintrag nicht vorhanden oder bereits freigeschaltet oder gel&ouml;scht!</div>\n";
		}
		else
			echo "<div class=\"box_access\">Zugriff verweigert!</div>\n";
		break;
	}
	case "comment":
	{
		if(!$_SESSION['login'])
		{
			echo "<div class=\"box_access\">Zugriff verweigert!</div>\n";
			break;
		}

		echo "<form action=\"".FILENAME."?p=comment&amp;i=".$_GET['i']."&amp;cp=".$_GET['cp']."\" method=\"post\">\n";
		echo "<table>\n";
		$file = file(DIR_DATA."/content");
		$item = explode("|@|", $file[$_GET['i']]);
		display_entry($item, $_GET['i'] + 1, false);
		echo "<tr><td colspan=\"2\" class=\"cell_border\">\n";
		echo "<strong>Kommentar</strong><br />\n";
		echo "<textarea name=\"comment\" class=\"fullwidth99\" cols=\"50\" rows=\"5\">".str_replace("<br />", "\n", $item[5])."</textarea>\n";
		echo "</td></tr>\n";
		echo "<tr><td colspan=\"2\" class=\"text_center\">\n";
		echo "<input type=\"submit\" name=\"save_comment\" value=\"Kommentar speichern\" />\n";
		echo "<input type=\"submit\" name=\"delete_comment\" value=\"Kommentar l&ouml;schen\" />\n";
		echo "<input type=\"button\" value=\"abbrechen\" onclick=\"location.href='".FILENAME."?page=".$_GET['cp']."'\" />\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		
		if(isset($_POST['save_comment']) || isset($_POST['delete_comment']))
		{
			$comment = "";
			if(isset($_POST['save_comment']))
			{
				$comment = clean_up($_POST['comment']);
				$comment = generate_html($comment);
			}
			$entries_comment = file(DIR_DATA."/content");
			$item_old = explode("|@|", $entries_comment[$_GET['i']]);
			$item_new = $item_old[0]."|@|".$item_old[1]."|@|".$item_old[2]."|@|".$item_old[3]."|@|".$item_old[4]."|@|".$comment."|@|".preg_replace("/(\r|\n|\t)/", "", $item_old[6])."|@|\n";
			$entries_comment[$_GET['i']] = $item_new;
			$file_comment = fopen(DIR_DATA."/content", "w");
			fputs($file_comment, implode("", $entries_comment));
			fclose($file_comment);
			echo "<script type=\"text/javascript\">location.href='".FILENAME."?page=".$_GET['cp']."';</script>";
		}
		break;
	}
	case "edit":
	{
		if(!$_SESSION['login'])
		{
			echo "<div class=\"box_access\">Zugriff verweigert!</div>\n";
			break;
		}
		
		$file = file(DIR_DATA."/content");
		$item = explode("|@|", $file[$_GET['i']]);
		echo "<form action=\"".FILENAME."?p=edit&amp;i=".$_GET['i']."&amp;cp=".$_GET['cp']."\" method=\"post\">\n";
		echo "<table class=\"fullwidth\">\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>Name</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"name\" size=\"40\" maxlength=\"40\" value=\"".$item[1]."\" /></td>\n</tr>\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>E-Mail Adresse</strong></td>\n";
		echo "<td class=\"cell_right\">\n";
		$mail = $item[2];
		if(strpos($item[2], "#") !== false)
			$mail = substr($mail, 1);
		echo "<input type=\"text\" name=\"email\" size=\"40\" maxlength=\"50\" value=\"".$mail."\" /><br />\n";
		echo "<input type=\"checkbox\" name=\"hidemail\" value=\"1\"".((strpos($item[2], "#") !== false) ? " checked=\"checked\"" : "")." />E-Mail Adresse nicht &ouml;ffentlich anzeigen\n";
		echo "</td>\n</tr>\n";
		echo "<tr>\n<td class=\"cell_left\"><strong>Homepage</strong></td>\n";
		echo "<td class=\"cell_right\"><input type=\"text\" name=\"homepage\" size=\"40\" maxlength=\"50\" value=\"".$item[3]."\" /></td>\n</tr>\n";
		echo "<tr>\n<td class=\"cell_left\">\n<strong>Eintrag</strong></td>\n";
		echo "<td class=\"cell_right\">\n";
		if($settings['BBCODES_ENABLED'])
		{
			echo "<a href=\"#\" onclick=\"bbCodeBold()\"><img src=\"".DIR_IMAGES_ICONS."/font_bold.png\" alt=\"fett\" /></a>&nbsp;\n";
			echo "<a href=\"#\" onclick=\"bbCodeItalic()\"><img src=\"".DIR_IMAGES_ICONS."/font_italic.png\" alt=\"kursiv\" /></a>&nbsp;\n";
			echo "<a href=\"#\" onclick=\"bbCodeUnderline()\"><img src=\"".DIR_IMAGES_ICONS."/font_underline.png\" alt=\"unterstrichen\" /></a>&nbsp;\n";
			echo "<a href=\"#\" onclick=\"bbCodeLink()\"><img src=\"".DIR_IMAGES_ICONS."/link.png\" alt=\"Link\" /></a>&nbsp;\n";
			echo "<a href=\"#\" onclick=\"bbCodeImage()\"><img src=\"".DIR_IMAGES_ICONS."/image.png\" alt=\"Bild\" /></a>\n";
			echo "<br />\n";
		}
		echo "<textarea name=\"entry\" id=\"entry\" class=\"fullwidth99\" cols=\"50\" rows=\"10\">".str_replace("<br />", "\n", $item[4])."</textarea>\n";
		if($settings['SMILEYS_ENABLED'])
		{
			$i = 0;
			foreach($smileys as $shortcut => $name)
			{
				if($i % 10 == 0)
					echo "<br />\n";
				echo "<a href=\"#\" onclick=\"bbCodeSmilie(' ".$shortcut."')\"><img src=\"".DIR_IMAGES_SMILEYS."/".$name.".png\" alt=\"".$shortcut."\" /></a>&nbsp;\n";
				$i++;
			}
		}
		echo "</td>\n</tr>\n";
		echo "<tr><td colspan=\"2\" class=\"text_center\">\n";
		echo "<input type=\"submit\" name=\"save\" value=\"speichern\" />\n";
		echo "<input type=\"button\" value=\"abbrechen\" onclick=\"location.href='".FILENAME."?page=".$_GET['cp']."'\" />\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		
		if(isset($_POST['save']))
		{
			$entry = clean_up($_POST['entry']);
			$entry = generate_html($entry);
			if(isset($_POST['hidemail']))
				$_POST['email'] = "#".$_POST['email'];
			$entries_edit = file(DIR_DATA."/content");
			$item_old = explode("|@|", $entries_edit[$_GET['i']]);
			$item_new = $item_old[0]."|@|".$_POST['name']."|@|".$_POST['email']."|@|".$_POST['homepage']."|@|".$entry."|@|".$item_old[5]."|@|".preg_replace("/(\r|\n|\t)/", "", $item_old[6])."|@|\n";
			$entries_edit[$_GET['i']] = $item_new;
			$file_edit = fopen(DIR_DATA."/content", "w");
			fputs($file_edit, implode("", $entries_edit));
			fclose($file_edit);
			echo "<script type=\"text/javascript\">location.href='".FILENAME."?page=".$_GET['cp']."';</script>";
		}
		break;
	}
	case "delete":
	{
		if(!$_SESSION['login'])
		{
			echo "<div class=\"box_access\">Zugriff verweigert!</div>\n";
			break;
		}

		echo "<form action=\"".FILENAME."?p=delete&amp;i=".$_GET['i']."&amp;cp=".$_GET['cp']."\" method=\"post\">\n";
		echo "<table>\n";
		$file = file(DIR_DATA."/content");
		$item = explode("|@|", $file[$_GET['i']]);
		display_entry($item, $_GET['i'] + 1);
		echo "<tr><td colspan=\"2\" class=\"text_center\">\n";
		echo "<input type=\"submit\" name=\"delete\" value=\"Eintrag l&ouml;schen\" />\n";
		echo "<input type=\"button\" value=\"abbrechen\" onclick=\"location.href='".FILENAME."?page=".$_GET['cp']."'\" />\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</form>\n";
		
		if(isset($_POST['delete']))
		{
			$entries_delete = file(DIR_DATA."/content");
			preg_match_all("/\[img\](.*)\[\/img\]/Usi", $entries_delete[$_GET['i']], $match_images);
			foreach ($match_images[1] as $url_image)
			{
				if(strpos($url_image, "gb_files/images_upload/") !== false && file_exists($url_image))
					unlink($url_image);
			}
			$entries_delete[$_GET['i']] = "";
			$file_delete = fopen(DIR_DATA."/content", "w");
			fputs($file_delete, implode("", $entries_delete));
			fclose($file_delete);
			echo "<script type=\"text/javascript\">location.href='".FILENAME."?page=".$_GET['cp']."';</script>";
		}
		break;
	}
}

echo "<div class=\"text_center\">\n";
echo "<hr />\n";
echo "tsGuestbook &copy; <a href=\"http://www.top-side.de\">top-side.de</a>\n";
echo "</div>\n";

echo "</div>\n";

echo "<div id=\"footer_login\">\n";
if($_SESSION['login'])
	echo "<img src=\"".DIR_IMAGES_ICONS."/loginok.png\" alt=\"Login\" /> eingeloggt | <a href=\"".FILENAME."?p=logout\">Logout</a>";
elseif($settings['SHOW_LOGIN_LINK'])
	echo "<img src=\"".DIR_IMAGES_ICONS."/login.png\" alt=\"Login\" />&nbsp;<a href=\"".FILENAME."?p=login\">Login</a>";
echo "</div>\n";

echo "</body>\n\n</html>";
?>